Files jbossts-full-4.2.1Beta1-src.ori/.build.xml.swp and jbossts-full-4.2.1Beta1-src.jdk-1.5.0/.build.xml.swp differ
diff -Nru jbossts-full-4.2.1Beta1-src.ori/ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/recovery/PeriodicRecovery.java jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/recovery/PeriodicRecovery.java
--- jbossts-full-4.2.1Beta1-src.ori/ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/recovery/PeriodicRecovery.java	2006-05-26 23:51:20.000000000 +0200
+++ jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/recovery/PeriodicRecovery.java	2006-06-14 11:15:42.000000000 +0200
@@ -307,7 +307,7 @@
                int position = 0;
 
                while ( position < moduleNames.size() &&
-                       attrName.compareTo( moduleNames.elementAt(position)) > 0 )
+                       attrName.compareTo((String)moduleNames.elementAt(position)) > 0 )
                {
                   position++;
                }
diff -Nru jbossts-full-4.2.1Beta1-src.ori/ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/recovery/RecActivatorLoader.java jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/recovery/RecActivatorLoader.java
--- jbossts-full-4.2.1Beta1-src.ori/ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/recovery/RecActivatorLoader.java	2006-05-26 23:51:20.000000000 +0200
+++ jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaCore/arjuna/classes/com/arjuna/ats/internal/arjuna/recovery/RecActivatorLoader.java	2006-06-14 11:16:22.000000000 +0200
@@ -109,7 +109,7 @@
 			      // this is one of ours - put it in the right place
 			      int position = 0;
 			      while ( position < activatorNames.size() &&
-				      attrName.compareTo( activatorNames.elementAt(position)) > 0 )
+				      attrName.compareTo((String)activatorNames.elementAt(position)) > 0 )
 				  {
 				      position++;
 				  }
diff -Nru jbossts-full-4.2.1Beta1-src.ori/ArjunaCore/build.xml jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaCore/build.xml
--- jbossts-full-4.2.1Beta1-src.ori/ArjunaCore/build.xml	2006-05-26 23:51:30.000000000 +0200
+++ jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaCore/build.xml	2006-06-14 11:26:38.000000000 +0200
@@ -60,12 +60,15 @@
 		<format property="com.hp.mw.date" pattern="yyyy/MMM/dd HH:mm"/>
 	  	</tstamp>
 
-		<condition property="JDK_1.4">
+		<condition property="SUPPORTED_JDK">
+                  <or>
 			<equals arg1="${java.specification.version}" arg2="1.4"/>
+			<equals arg1="${java.specification.version}" arg2="1.5"/>
+                  </or>
 		</condition>
 
-	    <fail unless="JDK_1.4">
-	      The ArjunaJTS build currently requires jdk1.4 to build.
+	    <fail unless="SUPPORTED_JDK">
+	      The ArjunaJTS build currently requires jdk1.4 or jdk1.5 to build.
 	    </fail>
 		
 		<property name="com.hp.mw.installationdirectory" location="install"/>
diff -Nru jbossts-full-4.2.1Beta1-src.ori/ArjunaJTA/build.xml jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaJTA/build.xml
--- jbossts-full-4.2.1Beta1-src.ori/ArjunaJTA/build.xml	2006-05-26 23:50:22.000000000 +0200
+++ jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaJTA/build.xml	2006-06-14 11:27:42.000000000 +0200
@@ -61,12 +61,15 @@
 		<format property="com.hp.mw.date" pattern="yyyy/MMM/dd HH:mm"/>
 	  	</tstamp>
 
-		<condition property="JDK_1.4">
+		<condition property="SUPPORTED_JDK">
+                  <or>
 			<equals arg1="${java.specification.version}" arg2="1.4"/>
+			<equals arg1="${java.specification.version}" arg2="1.5"/>
+                  </or>
 		</condition>
 
-	    <fail unless="JDK_1.4">
-	      The ArjunaJTS build currently requires jdk1.4 to build.
+	    <fail unless="SUPPORTED_JDK">
+	      The ArjunaJTS build currently requires jdk1.4 or jdk1.5 to build.
 	    </fail>
 		
 		<property name="com.hp.mw.installationdirectory" location="install"/>
diff -Nru jbossts-full-4.2.1Beta1-src.ori/ArjunaJTS/build.xml jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaJTS/build.xml
--- jbossts-full-4.2.1Beta1-src.ori/ArjunaJTS/build.xml	2006-05-26 23:51:02.000000000 +0200
+++ jbossts-full-4.2.1Beta1-src.jdk-1.5.0/ArjunaJTS/build.xml	2006-06-14 11:26:26.000000000 +0200
@@ -64,12 +64,15 @@
 		<format property="com.hp.mw.date" pattern="yyyy/MMM/dd HH:mm"/>
 	  	</tstamp>
 
-		<condition property="JDK_1.4">
+		<condition property="SUPPORTED_JDK">
+                  <or>
 			<equals arg1="${java.specification.version}" arg2="1.4"/>
+			<equals arg1="${java.specification.version}" arg2="1.5"/>
+                  </or>
 		</condition>
 
-	    <fail unless="JDK_1.4">
-	      The ArjunaJTS build currently requires jdk1.4 to build.
+	    <fail unless="SUPPORTED_JDK">
+	      The ArjunaJTS build currently requires jdk1.4 or jdk1.5 to build.
 	    </fail>
 		
 		<property name="com.hp.mw.installationdirectory" location="install"/>
diff -Nru jbossts-full-4.2.1Beta1-src.ori/XTS/build.xml jbossts-full-4.2.1Beta1-src.jdk-1.5.0/XTS/build.xml
--- jbossts-full-4.2.1Beta1-src.ori/XTS/build.xml	2006-05-26 23:51:52.000000000 +0200
+++ jbossts-full-4.2.1Beta1-src.jdk-1.5.0/XTS/build.xml	2006-06-14 11:25:52.000000000 +0200
@@ -78,12 +78,15 @@
 		<format property="com.arjuna.mw.date" pattern="yyyy/MMM/dd HH:mm"/>
 	  	</tstamp>
 
-		<condition property="JDK_1.4">
+		<condition property="SUPPORTED_JDK">
+                  <or>
 			<equals arg1="${java.specification.version}" arg2="1.4"/>
+			<equals arg1="${java.specification.version}" arg2="1.5"/>
+                  </or>
 		</condition>
 
-	    <fail unless="JDK_1.4">
-	      The ArjunaJTS build currently requires jdk1.4 to build.
+	    <fail unless="SUPPORTED_JDK">
+	      The ArjunaJTS build currently requires jdk1.4 or jdk1.5 to build.
 	    </fail>
 		
 		<property name="com.arjuna.mw.installationdirectory" location="xts-install"/>
diff -Nru jbossts-full-4.2.1Beta1-src.ori/build.xml jbossts-full-4.2.1Beta1-src.jdk-1.5.0/build.xml
--- jbossts-full-4.2.1Beta1-src.ori/build.xml	2006-05-26 23:51:52.000000000 +0200
+++ jbossts-full-4.2.1Beta1-src.jdk-1.5.0/build.xml	2006-06-14 11:28:08.000000000 +0200
@@ -31,6 +31,8 @@
    <property name="jts.dir" location="ArjunaJTS"/>
    <property name="integration.dir" location="atsintegration"/>
 
+   <property file="build.properties" />
+
    <available property="jts.present" file="${jts.dir}" type="dir"/>
 
    <target name="help">
@@ -161,12 +163,15 @@
          <format property="com.hp.mw.date" pattern="yyyy/MMM/dd HH:mm"/>
       </tstamp>
 
-      <condition property="JDK_1.4">
-         <equals arg1="${java.specification.version}" arg2="1.4"/>
+      <condition property="SUPPORTED_JDK">
+        <or>
+          <equals arg1="${java.specification.version}" arg2="1.4"/>
+          <equals arg1="${java.specification.version}" arg2="1.5"/>
+        </or>
       </condition>
 
-      <fail unless="JDK_1.4">
-         The JBossJTS build currently requires jdk1.4 to build.
+      <fail unless="SUPPORTED_JDK">
+         The JBossJTS build currently requires jdk1.4 or jdk1.5 to build.
       </fail>
       
       <property name="com.hp.mw.ts.product.propertyfile" value="${com.hp.mw.ts.product.name.lowercase}-properties.xml"/>