diff -ru jboss-orig/testsuite/src/main/org/jboss/test/jca/adapter/MockedXADataSource.java jboss/testsuite/src/main/org/jboss/test/jca/adapter/MockedXADataSource.java
--- jboss-orig/testsuite/src/main/org/jboss/test/jca/adapter/MockedXADataSource.java	2006-09-26 08:39:46.000000000 -0400
+++ jboss/testsuite/src/main/org/jboss/test/jca/adapter/MockedXADataSource.java	2007-06-22 15:40:13.000000000 -0400
@@ -21,24 +21,16 @@
  */
 package org.jboss.test.jca.adapter;
 
-import javax.sql.XADataSource;
-import javax.sql.XAConnection;
-import javax.sql.ConnectionEventListener;
+import javax.sql.*;
 import javax.transaction.xa.XAResource;
 import javax.transaction.xa.XAException;
 import javax.transaction.xa.Xid;
 import java.util.Map;
 import java.util.HashMap;
 import java.util.Arrays;
+import java.util.Properties;
 import java.io.PrintWriter;
-import java.sql.SQLException;
-import java.sql.Connection;
-import java.sql.DatabaseMetaData;
-import java.sql.SQLWarning;
-import java.sql.Savepoint;
-import java.sql.Statement;
-import java.sql.CallableStatement;
-import java.sql.PreparedStatement;
+import java.sql.*;
 import java.lang.reflect.Proxy;
 import java.lang.reflect.InvocationHandler;
 import java.lang.reflect.Method;
@@ -150,6 +142,14 @@
       {
       }
 
+      public void removeStatementEventListener(StatementEventListener listener)
+      {
+      }
+   
+      public void addStatementEventListener(StatementEventListener listener)
+      {
+      }
+
       class MockedConnection
          implements Connection
       {
@@ -159,6 +159,84 @@
          private boolean readOnly;
          private String catalog;
 
+         public Clob createClob() throws SQLException
+         {
+	    // TODO: Implement me
+	    return null;
+         }
+
+         public Blob createBlob() throws SQLException
+         {
+	    // TODO: Implement me
+	    return null;
+         }
+
+         public NClob createNClob() throws SQLException
+         {
+            // TODO: Implement me   
+            return null;
+         }
+
+         public SQLXML createSQLXML() throws SQLException
+         {
+            // TODO: Implement me
+            return null;
+         }
+
+         public boolean isValid(int timeout) throws SQLException
+         {
+            // TODO: Implement me
+            return false;
+         }
+
+         public void setClientInfo(String name, String value)
+                                               throws SQLClientInfoException
+         {
+            // TODO: Implement me
+         }
+
+         public void setClientInfo(Properties properties)
+                                                throws SQLClientInfoException
+         {
+            // TODO: Implement me
+         }
+
+         public String getClientInfo(String name) throws SQLException
+         {
+            // TODO: Implement me
+           return null;
+         }
+
+         public Properties getClientInfo() throws SQLException
+         {
+            // TODO: Implement me
+           return null;
+         }
+
+         public Array createArrayOf(String typeName, Object[] elements)                                                                       throws SQLException
+         {
+            // TODO: Implement me
+            return null;
+         }
+         
+         public Struct createStruct(String typeName, Object[] attributes) throws SQLException
+         {
+            // TODO: Implement me
+           return null;
+         }
+
+         public boolean isWrapperFor(Class<?> iface) throws SQLException
+         {
+            // TODO: Implement me
+           return false;
+         }
+
+         public <T> T unwrap(Class<T> iface) throws SQLException
+         {
+            // TODO: Implement me
+            return null;
+         } 
+
          public String getUrl()
          {
             return url;
diff -ru jboss-orig/testsuite/src/main/org/jboss/test/jca/jdbc/TestConnection.java jboss/testsuite/src/main/org/jboss/test/jca/jdbc/TestConnection.java
--- jboss-orig/testsuite/src/main/org/jboss/test/jca/jdbc/TestConnection.java	2006-09-26 08:39:46.000000000 -0400
+++ jboss/testsuite/src/main/org/jboss/test/jca/jdbc/TestConnection.java	2007-06-22 15:44:41.000000000 -0400
@@ -21,13 +21,9 @@
  */
 package org.jboss.test.jca.jdbc;
 
-import java.sql.Connection;
-import java.sql.SQLException;
-import java.sql.Statement;
-import java.sql.PreparedStatement;
-import java.sql.CallableStatement;
-import java.sql.DatabaseMetaData;
+import java.sql.*;
 import java.util.Map;
+import java.util.Properties;
 import java.sql.SQLWarning;
 import java.sql.Savepoint;
 
@@ -255,4 +251,68 @@
    {
    }
 
+   public Clob createClob() throws SQLException
+   {
+      return null;
+   }
+
+   public Blob createBlob() throws SQLException
+   {
+      return null;
+   }
+
+   public NClob createNClob() throws SQLException
+   {
+      return null;
+   }
+
+   public SQLXML createSQLXML() throws SQLException
+   {
+      return null;
+   }
+
+   public boolean isValid(int timeout) throws SQLException
+   {
+      return false;
+   }
+
+   public void setClientInfo(String name, String value)
+                 throws SQLClientInfoException
+   {
+   }
+
+   public void setClientInfo(Properties properties)
+                  throws SQLClientInfoException
+   {
+   }
+
+   public String getClientInfo(String name) throws SQLException
+   {
+     return null;
+   }
+
+   public Properties getClientInfo() throws SQLException
+   {
+     return null;
+   }
+
+   public Array createArrayOf(String typeName, Object[] elements) throws SQLException
+   {
+      return null;
+   }
+
+   public Struct createStruct(String typeName, Object[] attributes) throws SQLException
+   {
+     return null;
+   }
+
+   public boolean isWrapperFor(Class<?> iface) throws SQLException
+   {
+     return false;
+   }
+
+   public <T> T unwrap(Class<T> iface) throws SQLException
+   {
+      return null;
+   }
 }// TestConnection
diff -ru jboss-orig/testsuite/src/main/org/jboss/test/jca/jdbc/TestPreparedStatement.java jboss/testsuite/src/main/org/jboss/test/jca/jdbc/TestPreparedStatement.java
--- jboss-orig/testsuite/src/main/org/jboss/test/jca/jdbc/TestPreparedStatement.java	2006-09-26 08:39:46.000000000 -0400
+++ jboss/testsuite/src/main/org/jboss/test/jca/jdbc/TestPreparedStatement.java	2007-06-22 15:58:26.000000000 -0400
@@ -25,17 +25,7 @@
 import java.io.Reader;
 import java.math.BigDecimal;
 import java.net.URL;
-import java.sql.Array;
-import java.sql.Blob;
-import java.sql.Clob;
-import java.sql.Date;
-import java.sql.ParameterMetaData;
-import java.sql.PreparedStatement;
-import java.sql.Ref;
-import java.sql.ResultSet;
-import java.sql.ResultSetMetaData;
-import java.sql.Time;
-import java.sql.Timestamp;
+import java.sql.*;
 import java.util.Calendar;
 
 /**
@@ -121,6 +111,10 @@
    {
    }
 
+   public void setClob(int i, Reader x, long l) throws SQLException
+   {
+   }
+
    public void setClob(int i, Clob x)
    {
    }
@@ -204,4 +198,83 @@
    public void setURL(int i, URL url)
    {
    }
+   public void setClob(int i, Reader reader) throws SQLException
+   {
+   }
+
+   public void setNCharacterStream(int parameterIndex, Reader value,
+                                       long length) throws SQLException
+   {
+   }
+
+   public void setNCharacterStream(int parameterIndex, Reader value)
+                                                         throws SQLException
+   {
+   }
+
+   public void setNString(int parameterIndex, String value)
+                                                        throws SQLException
+   {
+   }
+
+   public void setCharacterStream(int parameterIndex,
+                                  java.io.Reader reader) throws SQLException
+   {
+   }
+
+   public void setBinaryStream(int i, java.io.InputStream input)
+                                              throws SQLException
+   {
+   }
+
+   public void setAsciiStream(int i, java.io.InputStream input)
+                                                throws SQLException
+   {
+   }
+
+   public void setCharacterStream(int i, Reader reader, long l)
+                                                throws SQLException
+   {
+   }
+
+   public void setBinaryStream(int i, java.io.InputStream input, long l)
+                                                throws SQLException
+   {
+   }
+
+   public void setNClob(int parameterIndex, NClob value) throws SQLException
+   {
+   }
+
+   public void setNClob(int parameterIndex, Reader reader) throws SQLException
+   {
+   }
+
+   public void setNClob(int parameterIndex, Reader reader, long l)
+                                                        throws SQLException
+   {
+   }
+
+   public void setBlob(int parameterIndex, java.io.InputStream inputStream,
+                                          long length) throws SQLException
+   {
+   }
+
+   public void setBlob(int parameterIndex, java.io.InputStream inputStream)
+                                                        throws SQLException
+   {
+   }
+
+   public void setAsciiStream(int i, java.io.InputStream input, long l)
+                                                throws SQLException
+   {
+   }
+
+   public void setSQLXML(int i,java.sql.SQLXML x) throws SQLException
+   {
+   }
+
+   public void setRowId(int i, java.sql.RowId d) throws SQLException
+   {
+   }   
 }
diff -ru jboss-orig/testsuite/src/main/org/jboss/test/jca/jdbc/TestStatement.java jboss/testsuite/src/main/org/jboss/test/jca/jdbc/TestStatement.java
--- jboss-orig/testsuite/src/main/org/jboss/test/jca/jdbc/TestStatement.java	2006-09-26 08:39:46.000000000 -0400
+++ jboss/testsuite/src/main/org/jboss/test/jca/jdbc/TestStatement.java	2007-06-22 16:00:26.000000000 -0400
@@ -59,6 +59,32 @@
    {
    }
 
+   public boolean isPoolable() throws SQLException
+   {
+      return false;
+   }
+
+   public void setPoolable(boolean p) throws SQLException
+   {
+   }
+
+   public boolean isClosed() throws SQLException
+   {
+      return false;
+   }
+
+   public <T> T unwrap(Class<T> iface)
+                           throws SQLException
+   {
+      return null;
+   }
+
+   public boolean isWrapperFor(Class<?> iface)
+                     throws SQLException
+   {
+      return false;
+   }
+
    /**
     *
     * @param param1 <description>
diff -ru jboss-orig/testsuite/src/main/org/jboss/test/security/test/LoginModulesUnitTestCase.java jboss/testsuite/src/main/org/jboss/test/security/test/LoginModulesUnitTestCase.java
--- jboss-orig/testsuite/src/main/org/jboss/test/security/test/LoginModulesUnitTestCase.java	2006-09-26 08:39:46.000000000 -0400
+++ jboss/testsuite/src/main/org/jboss/test/security/test/LoginModulesUnitTestCase.java	2007-06-22 15:47:41.000000000 -0400
@@ -365,6 +365,17 @@
       {
          return getConnection("sa", "");
       }
+
+      public boolean isWrapperFor(Class<?> iface) throws SQLException
+      {
+        return false;
+      }
+
+      public <T> T unwrap(Class<T> iface) throws SQLException
+      {
+         return null;
+      }
+ 
       public java.sql.Connection getConnection(String user, String pass) throws java.sql.SQLException
       {
 			java.sql.Connection con = null;